/*
 * echo/echo-pthread.c --
 *
 *      A simple program to start and join threads.
 */

#define _POSIX_C_SOURCE 200809L

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pthread.h>

typedef struct {
    char *msg;
    pthread_t thread;
} worker_t;

static void* work(void *data)
{
    worker_t *worker = (worker_t *) data;
    (void) printf("%s ", worker->msg);
    return NULL;
}

int main(int argc, char *argv[])
{
    int rc, status = EXIT_SUCCESS;
    worker_t worker[argc];

    for (int i = 1; i < argc; i++) {
        worker[i].msg = argv[i];
        rc = pthread_create(&worker[i].thread, NULL, work, &worker[i]);
        if (rc) {
            fprintf(stderr, "pthread_create() failed: %s\n", strerror(rc));
            status = EXIT_FAILURE;
            memset(&worker[i], 0, sizeof(worker[i]));
        }
    }

    for (int i = 1; i < argc; i++) {
        if (worker[i].thread) {
            rc = pthread_join(worker[i].thread, NULL);
            if (rc) {
                fprintf(stderr, "pthread_join() failed: %s\n", strerror(rc));
                status = EXIT_FAILURE;
            }
        }
    }

    (void) puts("");
    if (fflush(stdout) || ferror(stdout)) {
        perror("write failed");
        status = EXIT_FAILURE;
    }
    
    return status;
}
